# QProgressBar Class Reference

The QProgressBar widget provides a horizontal progress bar. More...

`#include <qprogressbar.h>`

Inherits QFrame.

List of all member functions.

## Public Members

- QProgressBar ( QWidget * parent=0, const char * name=0, WFlags f=0 )
- QProgressBar ( int totalSteps, QWidget * parent=0, const char * name=0, WFlags f=0 )
- int totalSteps () const
- int progress () const
- virtual QSize sizeHint () const
- virtual void show ()

## Public Slots

- void reset ()
- void setTotalSteps ( int totalSteps )
- void setProgress ( int progress )

## Protected Members

- virtual void drawContents ( QPainter * )
- virtual bool setIndicator ( QString & progress_str, int progress, int totalSteps )

## Detailed Description

The QProgressBar widget provides a horizontal progress bar.

A progress bar is used to give the user an indication of progress of an operation. To reassure them that the application has not crashed.

QProgressBar only implements the basic progress display, while QProgressDialog provides a fuller encapsulation.

See also: QProgressDialog and GUI Design Handbook: Progress Indicator

## Member Function Documentation

### QProgressBar::QProgressBar ( QWidget * parent=0, const char * name=0, WFlags f=0 )

Constructs a progress bar.

The total number of steps is set to 100 by default.

parent, name and f are sent to the QFrame::QFrame() constructor.

See also: setTotalSteps().

### QProgressBar::QProgressBar ( int totalSteps, QWidget * parent=0, const char * name=0, WFlags f=0 )

Constructs a progress bar.

totalSteps is the total number of steps in the operation of which this progress bar shows the progress. For example, if the operation is to examine 50 files, this value would be 50, then before examining the first file, call setProgress(0), and after examining the last file call setProgress(50).

parent, name and f are sent to the QFrame::QFrame() constructor.

See also: setTotalSteps() and setProgress().

### void QProgressBar::drawContents ( QPainter * p ) `[virtual protected]`

Handles paint events for the progress bar. In WindowsStyle, colorGroup().text() and QApplication::winStyleHighlightColor() are used. In MotifStyle, colorGroup().base() is also used.

Reimplemented from QFrame.

### int QProgressBar::progress () const

Returns the current amount of progress, or -1 if the progress counting has not started.

See also: setProgress().

### void QProgressBar::reset () `[slot]`

Reset the progress bar. The progress bar `rewinds'.

### bool QProgressBar::setIndicator ( QString & indicator, int progress, int totalSteps ) `[virtual protected]`

This method is called to generate the text displayed in the center of the progress bar.

The progress may be negative, indicating that the bar is in the "reset" state before any progress is set.

The default implementation it is the percentage of completion or blank in the reset state.

This method should return FALSE if the string is unchanged since the last call to the method, to allow efficient repainting of the progress bar.

### void QProgressBar::setProgress ( int progress ) `[slot]`

Sets the current amount of progress made to progress units of the total number of steps.

See also: progress() and totalSteps().

### void QProgressBar::setTotalSteps ( int totalSteps ) `[slot]`

Sets the total number of steps to totalSteps.

See also: totalSteps().

### QSize QProgressBar::sizeHint () const `[virtual]`

Returns a size which fits the contents of the progress bar.

Reimplemented from QWidget.

### int QProgressBar::totalSteps () const

Returns the total number of steps.

See also: setTotalSteps().

Search the documentation, FAQ, qt-interest archive and more (uses www.troll.no):

This file is part of the Qt toolkit, copyright © 1995-99 Troll Tech, all rights reserved.

It was generated from the following files:

- qprogressbar.h: 1998/08/21
- qprogressbar.cpp: 1998/08/12